<template>
	<div class="row d-flex align-items-center">
		<div class="col-6">
			<h3>
				Задачи
			</h3>
		</div>
		<div class="col-6 d-flex justify-content-end">
			<!-- <a-button type="primary" icon="calendar" @click="showTasksHelper">Новая задача</a-button> -->
		</div>
		<div class="col-12 mb-3">
			<a-calendar @panelChange="onDateChange" @select="onDateSelect">
			    <ul class="events" slot="dateCellRender" slot-scope="value">
			      <li v-for="event in renderEvents(value, events)">
			        <a-badge :status="event.status" :text="event.title" />
			      </li>
			    </ul>
			    <!-- <template slot="monthCellRender" slot-scope="value">
			      <div v-if="getMonthData(value)" class="notes-month">
			        <section>{{getMonthData(value)}}</section>
			        <span>Backlog number</span>
			      </div>
			    </template> -->
			</a-calendar>
		</div>
	</div>
</template>

<script>
	import moment from 'moment';
	import underscore from 'underscore';
	import 'moment/locale/ru';

	moment.locale('ru');

	export default {
		data () {
			return {
				events: ''
			}
		},
		created () {
			this.loadTasks(moment().format('YYYY-MM'));
		},
	    methods: {
		    onDateChange (value) {
		    	this.loadTasks(value.format('YYYY-MM'));
		    },
		    onDateSelect (value) {
		    	this.$router.push({ name: 'currentTasksPage', params: { date: value.format('YYYY-MM-DD')} })
		    },
		    loadTasks (date) {
		    	let data = {
		    		firstDate: date+'-01', 
		    		lastDate: date+'-31' 
		    	}
		    	this.$http.post(this.$store.state.api.url+'getTasks', data)
		    	.then(this.loadTasksSuccess,this.loadTasksError);
		    },
		    loadTasksSuccess (res) {
		    	this.events = res.body;
		    },
		    loadTasksError (err) {
		    	console.log(err);
		    },
		    renderEvents (value, data) {
		    	let date = value.format('YYYY-MM-DD');
		    	return underscore.where(data, {created_at: date+' 00:00:00'});
		    },
		    showTasksHelper () {
		    	this.$info({
			        title: 'Как создать задачу?',
			        content: 'Чтобы создать новую задачу, выберите конкретную дату.',
			        okText: 'Понятно',
			        onOk() {}
			    });
		    }
	    }
	}
</script>

<style scoped>
	.events {
	    list-style: none;
	    margin: 0;
	    padding: 0;
	}
	.events .ant-badge-status {
	    overflow: hidden;
	    white-space: nowrap;
	    width: 100%;
	    text-overflow: ellipsis;
	    font-size: 12px;
	}
	.notes-month {
	    text-align: center;
	    font-size: 28px;
	}
	.notes-month section {
	    font-size: 28px;
	}
	.task-list {
		border: 1px solid #e8e8e8;
	}
	.task-list .task {
		border-bottom: 1px solid #e8e8e8;
	}
	.task-list .task:last-child {
		border-bottom: none;
	}
</style>